/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : blobsearch.h
* Author             : AST Robotics group
* Date First Issued  : 28 Dec 2007 : Version 1.0
* Description        : header file for blobsearch.c
********************************************************************************
* History:
* 28 Dec 2007:Version 1.0
*******************************************************************************
 THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH
 CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
 AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
 OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT
 OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION
 CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef __BLOBSEARCH_255_H
#define __BLOBSEARCH_255_H

/* Includes ------------------------------------------------------------------*/
#include "utils.h"
#include "CamInt_x24.h"

//#define CODE_ON_PC // Comment this line to run the code on the micro

#define MAX_PERIMETER 	2000
#define MAX_AREA 	30000
#define MAX_BLOBS 	10
#define MAX_COLOR_SETS 	8

#define MAX_START_POINT 1000

/* CODE ----------------------------------------------------------------------*/

/* Exported types ------------------------------------------------------------*/

typedef struct {
	u8 X, Y;
} TPoint;

typedef struct {
	u8 X, Y, IDCol;
} TStartPoint;

typedef struct {
	u8 X, Y, Dir;
} TContour;

typedef struct {
	u8 Top, Bottom, Left, Right;
} TRect;

typedef struct {
	u8     BlobID;
	u8     ColorSetID;
	TPoint Centroid;
	TRect  OuterBox;
	u16    Perimeter;
	s16    Area;
	u8     Circularity;
#ifdef CODE_ON_PC
	u16    ContourLenght;
	TPoint Contour[MAX_PERIMETER];
#endif
} TBlobInfo;

typedef struct {
	u8    GridSize;
//	u8    ColorSetNum;
	TRect SearchRect;
} TSearchOptions;

typedef struct {
	u16 MinPer,  MaxPer;
	u16 MinArea, MaxArea;
	u8  MinCirc, MaxCirc;
} TColorSetParam;

/* Exported constants --------------------------------------------------------*/
/* Exported variables --------------------------------------------------*/
extern TSearchOptions SearchOptions;   // Search options
extern TColorSetParam ColorSetParam[];  // 
extern u8 BlobCount;                   // Number of found blobs
extern TBlobInfo Blobs[];               // Found blobs

/* Exported macro ------------------------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */

void BlobSearchInit(void);
int BlobSearch(u16 *pImg);
void BlobSearchSetColParam(u8 IDCol, u16 MinPer, u16 MaxPer, u16 MinArea, u16 MaxArea, u8 MinCirc, u8 MaxCirc);
void BlobSearchSetOption(u8 GridSize, u8 Top, u8 Bottom, u8 Left, u8 Right);

#endif /*__BLOBSEARCH_255_H*/


/******************* (C) COPYRIGHT 2007 STMicroelectronics *****END OF FILE****/
