/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : definitionsLib.h
* Author             : AST Robotics group
* Date First Issued  : 16 Apr 2009 : Version 1.0
* Description        : generic definitions and pin assignments file for x24 Engine.
********************************************************************************
* History:
* 28 May 2007 : Version 1.2
* 11 May 2007 : Version 1.0
*******************************************************************************
 THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH
 CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
 AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
 OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT
 OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION
 CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef DEFINITIONSLIB_H_
#define DEFINITIONSLIB_H_

//IRQ Priority    // 0 Highest, 15 Lowest
#define x24_DMA_ITPriority        0
#define x24_VSYNC_INT_ITPriority  3
#define x24_SYNC_TIM_IPriority    4

// x24 CONFIGURATION
#define x24_CE_GPIO GPIO4
#define x24_CE_GPIOx_Pin GPIO_Pin_5

#define x24_PCLK_GPIO GPIO3 // always GPIO3 (P3.0/P3.1)
#define x24_PCLK_GPIOx_Pin GPIO_Pin_0 // P3.0/P3.1
#define x24_PCLK_DMA_Channel DMA_Channel0
#define x24_PCLK_DMA_Channel_N 0
#define x24_PCLK_EXT_DMA_REQ_x DMA_SRC_External_Req0

#define x24_VSYNC_GPIO GPIO7
#define x24_VSYNC_GPIOx_Pin GPIO_Pin_7
#define x24_VSYNC_INT_WIU_Line ((u32)WIU_Line31)
#define x24_VSYNC_INT_WIU_Line_N 31
#define x24_VSYNC_INT_ITx_LINE EXTIT3_ITLine

#ifndef NoSync
  // #define x24_SYNC_LED_GPIO GPIO3
  // #define x24_SYNC_LED_GPIOx_Pin GPIO_Pin_1
  #define x24_SYNC_IN_GPIO GPIO4
  #define x24_SYNC_IN_GPIOx_Pin GPIO_Pin_7
  #define x24_SYNC_IN_ALT GPIO_InputAlt1
  #define x24_VSYNC_T_GPIO GPIO4
  #define x24_VSYNC_T_GPIOx_Pin GPIO_Pin_6
  #define x24_VSYNC_T_ALT GPIO_InputAlt1
  #define x24_SYNC_TIM TIM3
  #define x24_SYNC_TIM_ITx_LINE TIM3_ITLine
  #define x24_SYNC_TIM_Res_us 1000
  #define x24_SYNC_OUT_GPIO GPIO4
  #define x24_SYNC_OUT_GPIOx_Pin GPIO_Pin_2
  #define x24_SYNC_OUT_ALT GPIO_OutputAlt2
  #define x24_SYNC_OUT_TIM TIM1
  #define x24_SYNC_SW_IT_LINE SW_ITLine
#endif

#define x24_EXT_CLK_GPIO GPIO4
#define x24_EXT_CLK_GPIOx_Pin GPIO_Pin_4
#define x24_EXT_CLK_GPIO_Alt GPIO_OutputAlt2
#define x24_EXT_CLK_TIMx TIM2

#define x24_DATA_BUS_GPIO GPIO6

#endif /*DEFINITIONSLIB_H_*/
