/*******************************************************************************
 *                            C STMicroelectronics
 *    Reproduction and Communication of this document is strictly prohibited
 *      unless specifically authorized in writing by STMicroelectronics.
 *------------------------------------------------------------------------------
 *                              Imaging Division
 *------------------------------------------------------------------------------
 * $Id: c4mChaf.h.rca 1.2 Wed Jul 23 10:36:06 2008 vitor.schwambach@st.com Experimental $
 *------------------------------------------------------------------------------
 * $Log: c4mChaf.h.rca $
 * 
 *  Revision: 1.2 Wed Jul 23 10:36:06 2008 vitor.schwambach@st.com
 *  No modification.
 * 
 *  Revision: 1.1 Fri Jul 18 13:56:52 2008 vitor.schwambach@st.com
 *  Initial version from AST
 ******************************************************************************/

/*******************************************************************************
 * CVS Id    $Id: c4mChaf.h.rca 1.2 Wed Jul 23 10:36:06 2008 vitor.schwambach@st.com Experimental $
 *
 * File:     c4mChaf.h
 *
 * Author:   Luigi Arnone
 * eMail:    luigi.arnone@st.com  
 *
 * Org:      Agrate Advanced System Technologies lab.
 *           STMicroelectronics S.r.l.
 *
 * Created:  2007-01-15
 *
 * Modified: 2007-02-14
 *
 * Purpose:  
 *
 * COPYRIGHT:
 * This program is property of Agrate Advanced System Technology
 * lab, from STMicroelectronics S.r.l.
 ******************************************************************************/

#ifndef __C4MCHAF_H_
#define __C4MCHAF_H_

#ifndef __C4MTYPES_H_
#include "c4mTypes.h"
#endif


#ifdef __cplusplus
extern "C" {
#endif

#define C4M_MERGE_NONE 0
#define C4M_MERGE_MEAN 1
#define C4M_MERGE_MIN_MAX 2

typedef struct _c4mChafType {
	c4mMatrix PatchSize;
	c4mMatrix PatchRange;
	c4mMatrix StagesNOfWeaks;
	c4mMatrix StagesThreshold;
	c4mMatrix WeaksThreshold;
	c4mMatrix WeaksAlpha;
	c4mMatrix WeaksParity;
	c4mMatrix WeaksFeaturesShape;
} c4mChafType;

static const char *c4mChafTypeFieldsNames[] = {
	"PatchSize",
	"PatchRange",
	"StagesNOfWeaks",
	"StagesThreshold",
	"WeaksThreshold",
	"WeaksAlpha",
	"WeaksParity",
	"WeaksFeaturesShape"
};

typedef struct _c4mChaf2SType {
	c4mMatrix PatchSize;
	c4mMatrix DoubleTreshold;
	c4mMatrix PatchRange;
	c4mMatrix StagesNOfWeaks;
	c4mMatrix StagesThreshold;
	c4mMatrix WeaksThreshold2;
	c4mMatrix WeaksAlpha;
	c4mMatrix WeaksThreshold1;
	c4mMatrix WeaksFeaturesShape;
} c4mChaf2SType;

static const char *c4mChaf2STypeFieldsNames[] = {
	"PatchSize",
	"DoubleTreshold",
	"PatchRange",
	"StagesNOfWeaks",
	"StagesThreshold",
	"WeaksThreshold2",
	"WeaksAlpha",
	"WeaksThreshold1",
	"WeaksFeaturesShape"
};

typedef struct _c4mChafTmpType {
	c4mMatrix IIm;
	c4mMatrix I2Im;
	c4mMatrix H;
} c4mChafTmpType;

static const char *c4mChafTmpTypeFieldsNames[] = {
	"IIm",
	"I2Im",
	"H"
};

typedef struct _c4mChafSearchType {
	c4mMatrix Resize;
	c4mMatrix StepGrid;
	c4mMatrix Window;
	c4mMatrix MergeMode;
	c4mMatrix SearchSchema;
	c4mMatrix MaxScore;
} c4mChafSearchType;


static const char *c4mChafSearchTypeFieldsNames[] = {
	"Resize",
	"StepGrid",
	"Window",
	"MergeMode",
	"SearchSchema",
	"MaxScore"
};

typedef struct _c4mChafSearchRotated {
	c4mMatrix CascadeName;
	c4mMatrix RotationParam;
} c4mChafSearchRotated;

static const char *c4mChafSearchTypeFieldsNamesR[] = {
	"CascadeName",
	"RotationParam",
};

#ifdef __cplusplus
}
#endif

#endif /* __C4MCHAF_H_ */
