/*******************************************************************************
 *                            C STMicroelectronics
 *    Reproduction and Communication of this document is strictly prohibited
 *      unless specifically authorized in writing by STMicroelectronics.
 *------------------------------------------------------------------------------
 *                              Imaging Division
 *------------------------------------------------------------------------------
 * $Id: c4mErrors.h.rca 1.2 Wed Jul 23 10:36:07 2008 vitor.schwambach@st.com Experimental $
 *------------------------------------------------------------------------------
 * $Log: c4mErrors.h.rca $
 * 
 *  Revision: 1.2 Wed Jul 23 10:36:07 2008 vitor.schwambach@st.com
 *  No modification.
 * 
 *  Revision: 1.1 Fri Jul 18 13:56:53 2008 vitor.schwambach@st.com
 *  Initial version from AST
 ******************************************************************************/

/*******************************************************************************
 * CVS Id    $Id: c4mErrors.h.rca 1.2 Wed Jul 23 10:36:07 2008 vitor.schwambach@st.com Experimental $
 *
 * File:     c4mErrors.h
 *
 * Author:   Luigi Arnone, Luca Mazzucco, Luca Piccini, Luca Petrelli, 
 *           Sergio Parini, Luca Maggi.
 *
 * eMail:    luigi.arnone@st.com  
 *
 * Org:      Agrate Advanced System Technologies lab.
 *           STMicroelectronics S.r.l.
 *           Politecnico di Milano - WOWS!Lab
 *
 * Created:  2005-06-01
 *
 * Modified: 2005-06-01
 *
 * Purpose:  
 *
 * COPYRIGHT:
 * This program is property of Agrate Advanced System Technology
 * lab, from STMicroelectronics S.r.l. and WOWS!Lab Politecnico di Milano
 ******************************************************************************/

#ifndef __C4MERRORS_H_
#define __C4MERRORS_H_

#ifndef __C4MTYPES_H_
#include "c4mTypes.h"
#endif


#ifdef __cplusplus
extern "C" {
#endif

#define C4M_RET_ERROR		0
#define C4M_RET_OK			1

#define C4M_GENERIC_ERROR	1
#define C4M_ERROR_STR_LEN	1000


typedef struct _c4mErrorCode {
	uint32 code;
	char *msg;
} c4mErrorCode;

c4mErrorCode *c4mGetError();

char *c4mGetErrorMsg();

uint32 c4mGetErrorCode();

int8 c4mSetError(uint32 code, char *msg);

int8 c4mErrMsgTxt(char *msg);

#ifdef __cplusplus
}
#endif

#endif /* __C4MERRORS_H_ */
