/*******************************************************************************
 *                            C STMicroelectronics
 *    Reproduction and Communication of this document is strictly prohibited
 *      unless specifically authorized in writing by STMicroelectronics.
 *------------------------------------------------------------------------------
 *                              Imaging Division
 *------------------------------------------------------------------------------
 * $Id: c4mTypes.h.rca 1.2 Wed Jul 23 10:36:12 2008 vitor.schwambach@st.com Experimental $
 *------------------------------------------------------------------------------
 * $Log: c4mTypes.h.rca $
 * 
 *  Revision: 1.2 Wed Jul 23 10:36:12 2008 vitor.schwambach@st.com
 *  No modification.
 * 
 *  Revision: 1.1 Fri Jul 18 13:56:56 2008 vitor.schwambach@st.com
 *  Initial version from AST
 ******************************************************************************/

#ifndef __C4MTYPES_H_
#define __C4MTYPES_H_


#ifdef __cplusplus
extern "C" {
#endif

#define IN
#define OUT
#define INOUT

#ifndef true
#define false 0
#define true (!false)
#endif
	
#ifdef __cplusplus
#define C4M_INLINE inline
#elif (defined WIN32 || defined WIN64) && !defined __GNUC__
#define C4M_INLINE __inline
#else
#define C4M_INLINE static
#endif

#if STD_RANGE_EVAL
extern int StdMin=0x7FFFFFFF;
extern int StdMax=0;
#endif

#if FEATURE_OPT_EVAL	
extern int ExtraFeatureCnt=0;
#endif

typedef char                    int8;
typedef unsigned char           uint8;

typedef short                   int16;
typedef unsigned short          uint16;

typedef int                     int32;
typedef unsigned int            uint32;

#if defined _MSC_VER || defined __BORLANDC__
typedef __int64                 int64;
typedef unsigned __int64        uint64;
#else
typedef long long               int64;
typedef unsigned long long      uint64;
#endif

typedef float                   float32;
typedef double                  float64;

typedef struct _complex32
{
	float32 r;
	float32 i;
} complex32;

typedef struct _complex64
{
	float64	r;
	float64 i;
} complex64;

typedef struct _c4mMatrix
{
	void*  pdata;
	uint32 rows;
	uint32 cols;
	uint16 esize;
	uint8  mode;
	uint8  fx;
} c4mMatrix;

typedef struct _c4mXMatrix
{
	void*   pdata;
	uint32* dims;
	uint32  ndim;
	uint16  esize;
	uint8   mode;
	uint8   fx;
} c4mXMatrix;

typedef struct _c4m2Matrix
{
	c4mMatrix mat1;
	c4mMatrix mat2;
} c4m2Matrix;

typedef struct _c4mFoundObj
{
  uint8  cascade;
  uint32 rotation;
  uint32 score;
  uint32 x0;
  uint32 y0;
  uint32 x1;
  uint32 y1;
} c4mFoundObj;

typedef struct _CollectData
{   
	uint32    noCascades;
	uint32**  stats;
	uint8*	  result;
    uint32*	  count_done;
	uint32*	  count_OK;
	uint32*	  count_QC;
} CollectData;

#define C4M_VERTICAL_SCAN		0
#define C4M_HORIZONTAL_SCAN		1

#define C4M_SET_ROWS(m, r)		{ ((m->mode) == C4M_HORIZONTAL_SCAN) ? m->cols = r : m->rows = r; }
#define C4M_SET_COLS(m, c)		{ ((m->mode) == C4M_HORIZONTAL_SCAN) ? m->rows = c : m->cols = c; }
#define C4M_SET_DIMS(m, r, c)	{ ((m->mode) == C4M_HORIZONTAL_SCAN) ? m->cols = r, m->rows = c : m->rows = r, m->cols = c; }

#define C4M_MATRIX_CLEAR(m) \
	memset((m)->pdata, 0, ((m)->rows) * ((m)->cols) * ((m)->esize))


#ifdef __cplusplus
}
#endif

#endif /* __C4MTYPES_H_ */
