/*******************************************************************************
 *                            C STMicroelectronics
 *    Reproduction and Communication of this document is strictly prohibited
 *      unless specifically authorized in writing by STMicroelectronics.
 *------------------------------------------------------------------------------
 *                              Imaging Division
 *------------------------------------------------------------------------------
 * $Id: fxp.h.rca 1.2 Wed Jul 23 10:36:12 2008 vitor.schwambach@st.com Experimental $
 *------------------------------------------------------------------------------
 * $Log: fxp.h.rca $
 * 
 *  Revision: 1.2 Wed Jul 23 10:36:12 2008 vitor.schwambach@st.com
 *  No modification.
 * 
 *  Revision: 1.1 Fri Jul 18 13:56:57 2008 vitor.schwambach@st.com
 *  Initial version from AST
 ******************************************************************************/

/*******************************************************************************
 *                       Copyright (c) STMicroelectronics
 *   Reproduction and Communication of this document is strictly prohibited 
 *   unless specifically authorized in writing by STMicroelectronics
 *******************************************************************************

 *******************************************************************************

 FILENAME  : fxp.h
 PROJECT   : Face2Face
 MODULE    : Tracking2D

 AUTHOR(S) : Angelo BOSCO (Advanced System Technology, Agrate)
			 Claudio MARCHISIO (Advanced System Technology, Agrate)

 COPYRIGHT : STMicroelectronics, 2006

    This document contains proprietary and confidential information of the
                         STMicroelectronics Group. All rights reserved.

 ----------------------------- MODULE DESCRIPTION -----------------------------

 Declarations used for fixed point arithmetics.

 ---------------------------------- HISTORY -----------------------------------

 2006.11.21 : (Claudio Marchisio, Angelo Bosco) Creation.

 ******************************************************************************/

#ifndef __FXP_H__
#define __FXP_H__

#ifndef __C4MSQRT_H_
#include "c4mSqrt.h"
#endif

#ifdef _USE_FXP

#define FXP_PRECISION_8				8
#define FXP_PRECISION_16			16

#define CONVERT_FROM_FXP_8(value)	(((value) + (1 << (FXP_PRECISION_8 - 1))) >> FXP_PRECISION_8)
#define CONVERT_FROM_FXP_16(value)	(((value) + (1 << (FXP_PRECISION_16 - 1))) >> FXP_PRECISION_16)

#define SQRT(value)					((c4mSqrtScalar_U(((uint32)value) << FXP_PRECISION_8) + (1 << 3)) >> 4)

#define IIR_FIXED_SHIFT				25			// 2^25 = 33554432
#define IIR_FIXED_ROUND				16777216	// 2^24 = 16777216

#define FIX2INT(a)					( ((a) >= 0) ? (( (a) + IIR_FIXED_ROUND) >> IIR_FIXED_SHIFT) : \
										( -(( (-a) + IIR_FIXED_ROUND) >> IIR_FIXED_SHIFT)) )

#else

#define SQRT(value)					sqrt(value)

#endif

#endif
