/*******************************************************************************
 *                            C STMicroelectronics
 *    Reproduction and Communication of this document is strictly prohibited
 *      unless specifically authorized in writing by STMicroelectronics.
 *------------------------------------------------------------------------------
 *                              Imaging Division
 *------------------------------------------------------------------------------
 * $Id: matrix_c.h.rca 1.2 Wed Jul 23 10:36:13 2008 vitor.schwambach@st.com Experimental $
 *------------------------------------------------------------------------------
 * $Log: matrix_c.h.rca $
 * 
 *  Revision: 1.2 Wed Jul 23 10:36:13 2008 vitor.schwambach@st.com
 *  No modification.
 * 
 *  Revision: 1.1 Fri Jul 18 13:56:57 2008 vitor.schwambach@st.com
 *  Initial version from AST
 ******************************************************************************/

/*******************************************************************************
 *                       Copyright (c) STMicroelectronics
 *   Reproduction and Communication of this document is strictly prohibited 
 *   unless specifically authorized in writing by STMicroelectronics
 *******************************************************************************

 *******************************************************************************

 FILENAME  : matrix_c.h
 PROJECT   : Face2Face
 MODULE    : Tracking2D

 AUTHOR(S) : Claudio MARCHISIO (Advanced System Technology, Agrate)

 COPYRIGHT : STMicroelectronics, 2006

 This document contains proprietary and confidential information of the
 STMicroelectronics Group. All rights reserved.

 ----------------------------- MODULE DESCRIPTION -----------------------------

 Declaration of helping functions working on the C4M matrix structure.

 ---------------------------------- HISTORY -----------------------------------

 2006.09.14 : (Claudio Marchisio) Creation.
 
 ******************************************************************************/

#ifndef __MATRIX_C_H_
#define __MATRIX_C_H_

#ifndef __C4MTYPES_H_
#include "c4mTypes.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
// CMARCH relaxed to test FaceFinderHaar  #ifndef _USE_FXP
	DTfloat32,
	DTfloat64,
// CMARCH relaxed to test FaceFinderHaar  #endif
	DTuint8,
	DTuint32
} DataType;


void ResetMatrix(c4mMatrix* matrix);
int AllocateMatrixBuffer(c4mMatrix* matrix, uint32 rows, uint32 cols, DataType datatype);
void ReleaseMatrixBuffer(c4mMatrix* matrix);
void ResetMatrixBuffer(c4mMatrix* matrix);

typedef struct {
	uint32 elems;
	c4mMatrix* matrices;
} c4mMatrixArray;


int AllocateMatrixArray(c4mMatrixArray* array, uint32 elems, uint32 rows, uint32 cols, DataType datatype);
void ReleaseMatrixArray(c4mMatrixArray* array);
void ResetMatrixArray(c4mMatrixArray* array);

#ifdef __cplusplus
}
#endif

#endif // __MATRIX_C_H_
