/*******************************************************************************
 *                            C STMicroelectronics
 *    Reproduction and Communication of this document is strictly prohibited
 *      unless specifically authorized in writing by STMicroelectronics.
 *------------------------------------------------------------------------------
 *                              Imaging Division
 *------------------------------------------------------------------------------
 * $Id: objectdistance.h.rca 1.2 Wed Jul 23 10:36:13 2008 vitor.schwambach@st.com Experimental $
 *------------------------------------------------------------------------------
 * $Log: objectdistance.h.rca $
 * 
 *  Revision: 1.2 Wed Jul 23 10:36:13 2008 vitor.schwambach@st.com
 *  No modification.
 * 
 *  Revision: 1.1 Fri Jul 18 13:56:57 2008 vitor.schwambach@st.com
 *  Initial version from AST
 ******************************************************************************/

#ifndef __OBJECTDISTANCE_H_
#define __OBJECTDISTANCE_H_

#ifndef __C4MTYPES_H_
#include "c4mTypes.h"
#endif


#ifdef __cplusplus
extern "C" {
#endif


/* SensorInfo: info on a particular camera sensor. */
typedef struct _SensorInfo {
	float32 focalLength;  /* Focal length [m]. */
	float32 pixelSize;    /* Size of the pixel sensor [m]. */
	uint32 nativeHeight;  /* Native height of the sensor [pixels]. */
} SensorInfo;

/* Info about some sensors. */
const SensorInfo SBV6851 = {0.00385f,  0.00000175f, 1536};
const SensorInfo VL6522  = {0.00253f,  0.0000036f,  480};


float32
GetObjectDistance(const SensorInfo* sensor, float32 realObjectSize, 
				  uint32 measuredObjectSize, uint32 workingHeight);

#ifdef __cplusplus
}
#endif

#endif
