/*
 * Demo.h
 *
 *  Created on: 6-ott-2009
 *      Author: Ghezzi
 */

#ifndef DEMO_H_
#define DEMO_H_

/* Includes ------------------------------------------------------------------*/
#include "91x_lib.h"
#include "serial_protocol.h"
#include "CamInt_x24.h"

/* Exported types ------------------------------------------------------------*/

typedef struct {
  u32 SrcAdd;    /* The current source address (byte-aligned) of the data to be transferred.*/
  u32 DesAdd;    /* The current destination address (byte-aligned) of the data to be transferred.*/
  u32 LLstItm;   /* The word- aligned address for the next Linked List Item. */
  u32 CCR;       /* The current Channel Control Register */
} TUART_DMA_LLI;

typedef struct {
  TUART_DMA_LLI    DMA_LLI;
  u8              *pDMA_Buffer;
  u16             StartOfMsg;
} TUart_Engine;

extern u8 ActiveDemo;
extern u8 CamStreaming;
extern vu8 SenderInterface;
/* Exported constants --------------------------------------------------------*/
#define UART_RxBufferSize (2*TMsg_MaxLen)
#define Uart_Msg_Max_Size TMsg_MaxLen

#define SENDER_UART		0x01
#define SENDER_USB		0x02

/* Module private variables --------------------------------------------------*/
extern u8 UART_RxBuffer[];
extern TUart_Engine Uart_Engine;
extern u8 *pImgBufferData;
extern u32 BufferSize;
extern u8 CamState; // 0:Uniitialized, 1:Running, 2:Paused
extern Tx24_ImgJob *CompletedJob;

/* Exported macro ------------------------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */
int HandleMSG(TMsg *Msg);
void CamJob_SM(void);
void Led_SM(void);
void YCbCrBug(u8 *Img, u16 Width, u16 Height);
int CamJob_Pause(void);
void x24_TIM_SYNC_Handler(void);
void Sync_HwConfig(void);

#endif /* DEMO_H_ */
