/******************** (C) COPYRIGHT 2006 STMicroelectronics ********************
* File Name          : usb_config.h
* Author             : MCD Application Team
* Date First Issued  : 10/01/2006 : V1.0
* Description        : Hardware Configuration & Setup
********************************************************************************
* History:
* 10/01/2006 : V1.0
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __USB_Config_H
#define __USB_Config_H

/* Includes ------------------------------------------------------------------*/
#include "fifo.h"

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported variables --------------------------------------------------------*/
#define USB_RxFifoDim 128
extern TCharFifo USB_RxFifo;
//extern u8 USB_buffer_in[];
//extern u32 USB_count_in;
extern volatile u8 USB_FlagTxProcess;
/* Exported macro ------------------------------------------------------------*/
/* Exported define -----------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */
void USB_endPointConf(void);
void USB_WriteBuffer_1(u8 *pBuffer, u8 Len); // like USB_WriteBuffer but limited to 60 bytes
void USB_WriteBuffer(u8 *pBuffer, u32 Len);
void USB_WriteBufferAshii(u8 *pBuffer, u32 Len);
void USB_WriteString(u8 *pString);
void USB_Cable_Config (FunctionalState NewState);
void Enter_LowPowerMode(void);
void Leave_LowPowerMode(void);

#endif /* __USB_Config_H */
/******************* (C) COPYRIGHT 2006 STMicroelectronics *****END OF FILE****/
