/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : DemoWebcam.c
* Author             : AST Robotics group
* Date First Issued  : 11 June 2007 : Version 1.0
* Description        : This file implements the usb-webcam demo
********************************************************************************
* History:
* 11 June 2007 : Version 1.0
*******************************************************************************
 THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH
 CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
 AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
 OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT
 OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION
 CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Standard include ----------------------------------------------------------*/
#include "DemoFast.h"
#include "Demo.h"
#include "91x_map.h"
#include "utils.h"
#include "definitions.h"
#include "CamInt_x24.h"
#include "usb_lib.h"
#include "usb_conf.h"
#include "usb_prop.h"
#include "usb_pwr.h"
#include "usb_config.h"
#include <string.h>
#include "serial_protocol.h"
#include "math.h"
#include "harris_section.h"
#include "fast.h"
/* Include of other module interface headers ---------------------------------*/
/* Local includes ------------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
//#define BUFFERSIZE_DbEMO_H	19200
#define BUFFERSIZE_DEMO_FAST     160*120
//ImgCol*ImgRow
//#define BUFFERSIZE_DEMO_H	4800
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

void DemoFast(TMsg *Msg)
{
  ActiveDemo = DEMO_Fast;

  u8 ImgBuffer[2*BUFFERSIZE_DEMO_FAST];
  TCorner FastPoint[DCORNERS];

  pImgBufferData = ImgBuffer;
  pFeature = FastPoint;

  BufferSize = BUFFERSIZE_DEMO_FAST;

//  MatrixInit((TMatrix*)&MSImg, MSImgDatas LMRow, LMCol, 4);

  MaxHPt = DCORNERS;
  HarrisTh = 100;
  //kh1_inv = 22;

//  HarrisInit();
  if(SenderInterface == SENDER_USB) {
	  USB_SendMsg(Msg);
  } else {
	  UART_SendMsg(Msg);
  }
//  USB_SendMsg(Msg);

  CamState=0;

  while(1) {
    Led_SM();
    CamJob_SM();
    if (USB_ReceivedMSG(Msg)) {
      if (Msg->Data[0]==DEV_ADDR) {
        if (HandleMSG(Msg)) {
          USB_SendMsg(Msg);
        }
      } else { // forward Msg to the other port
        UART_SendMsg(Msg);
      }
    }
    if (UART_ReceivedMSG(Msg)) {
      if (Msg->Data[0]==DEV_ADDR) {
        if (HandleMSG(Msg)) {
          UART_SendMsg(Msg);
        }
      } else { // forward Msg to the other port
        USB_SendMsg(Msg);
      }
    }
  }
}
#define MaxPtPerPacket 20
int Handle_CMD_GetFastPoints(TMsg *Msg)
{
  u32 i;
  u8 *pD;
  u16 PktNum=Msg->Data[3];
  u16 pointPerPacket;

  if(PktNum == 0) {
	  if (x24_Engine.Res_Colour_Type!=x24_ImageFormat_YCbCr_400) {
		  return 0;
	  } else {
		  YCbCrBug((u8 *)CompletedJob->pFirstBlock->pData, x24_Engine.Row_Size, (u16)CompletedJob->pFirstBlock->CurrentBlockRow);
	  }
	  if (!CamJob_Pause()) return 0;
	  Serialize(&Msg->Data[3], CompletedJob->FrameCount, 2);

	  HPtCount=0;

	  //LED_ON(LEDR);


//Fast corner detection
//  fast9_detect_nonmax(CompletedJob->pFirstBlock->pData, ImgCol, ImgRow, ImgCol, HarrisTh, &HPtCount, pHarrisPoint);
	  MY_ON();
	  HPtCount=fast(CompletedJob->pFirstBlock->pData, x24_Engine.Res_Width, x24_Engine.Res_Height, HarrisTh, pFeature, MaxHPt);
	  MY_OFF();
	  //LED_OFF(LEDR);
  }

  if(HPtCount>MaxHPt) HPtCount=MaxHPt;

  Msg->Data[5]=HPtCount;

  if((HPtCount-(PktNum*MaxPtPerPacket))<MaxPtPerPacket)
	  pointPerPacket = HPtCount-(PktNum*MaxPtPerPacket);
  else
	  pointPerPacket = MaxPtPerPacket;

//  if(HPtCount > MaxHPt)
//	  HPtCount=MaxHPt;
  pD=&Msg->Data[6];
  for (i=PktNum*MaxPtPerPacket; i<HPtCount || i<(PktNum*MaxPtPerPacket+MaxPtPerPacket); i++) {
    *pD=pFeature[i].X; pD++;
    *pD=pFeature[i].Y; pD++;
    Serialize(pD, pFeature[i].Score, 2); pD+=2; // Fast Measure
  }
  Msg->Len=4*pointPerPacket+6;

//  MSDelay(200);
  return 1;
}

int Handle_CMD_FastSettings(TMsg *Msg)
{
//  u32 i;
//  u8 *pD;

  MaxHPt = Deserialize(&Msg->Data[3], 2);
//  MaxHPt=100;
  HarrisTh = Deserialize(&Msg->Data[5], 2);
//  kh1_inv = Deserialize(&Msg->Data[7], 2);
  if(MaxHPt>GlobalMaxHPt) {
	  MaxHPt=GlobalMaxHPt;
  }
  Msg->Len=3;
  return 1;
}

/******************* (C) COPYRIGHT 2007 STMicroelectronics *****END OF FILE****/
